package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.common.exception.DbException;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrIndividualBusinessAbnormality;
import com.zksy.data.domain.response.XcrIndividualBusinessAbnormalityResponse;
import com.zksy.data.mapper.XcrIndividualBusinessAbnormalityMapper;
import com.zksy.data.service.XcrIndividualBusinessAbnormalityService;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.support.TransactionTemplate;

import java.util.List;
import java.util.Vector;

/**
* @author 邵洋
* @description 针对表【xcr_individual_business_abnormality(个体经营异常标记信息表)】的数据库操作Service实现
* @createDate 2024-10-20 17:50:07
*/
@Service
@Slf4j
public class XcrIndividualBusinessAbnormalityServiceImpl extends ServiceImpl<XcrIndividualBusinessAbnormalityMapper, XcrIndividualBusinessAbnormality>
    implements XcrIndividualBusinessAbnormalityService{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Autowired
    private TransactionTemplate transactionTemplate;

    @Override
    @XhDataLogRecord("同步个体经营异常标记信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrIndividualBusinessAbnormality> toDatabaseList = new Vector<>();
        creditCodes.parallelStream().forEach(creditCode -> {
            List<XcrIndividualBusinessAbnormality> list = xhRequestUtil.httpRequestByUniCode(creditCode, address,
                    XcrIndividualBusinessAbnormalityResponse.class,
                    XcrIndividualBusinessAbnormality.class
            );
            if(list != null){
                toDatabaseList.addAll(list);
            }
        });
        transactionTemplate.execute((s)->{
            try {
                this.remove(null);
                this.saveBatch(toDatabaseList);
            } catch (Exception e) {
                s.setRollbackOnly();
                throw new DbException(e);
            }
            return null;
        });
        log.info("个体经营异常标记信息同步完成");
    }
}




